<% @Language=VBScript %>
<!-- #include file="routines.vbs" -->
<%
    Function CheckExt(s)
        If s = "" Then 
            CheckExt = False
        ElseIf Instr(s,".") > 0 Or InStr(s,":") > 0 Or InStr(s,";") > 0 Then
            CheckExt = False
        Else
            CheckExt = True
        End If
    End Function
    
    Sub AddTMLVars(ext)
        Dim v, r, strm, line, n, vName
        If Not IsObject(ext("REPLACE")) Then
            ext.Add "REPLACE", cfg.CreateSection
        End If
        Set v = ext("REPLACE")
        Set strm = sf.CreateMemoryStream
        strm.WriteText CStr(Request("Vars"))
        strm.Pos = 0
        While Not strm.EOS
            line = strm.ReadText(-1)
            n = InStr(line,"=")
            If n > 0 Then
                vName = Left(line,n-1)
                If Not IsObject(v(vName)) Then
                    v.Add vName, cfg.CreateRecord
                End If
                v(vName).Add "", Right(line, Len(line) - n)
            End If
        Wend
        Set strm = Nothing
    End Sub
    
    Dim errMode(3), cgiTypes(3)
    errMode(0) = "ALP standard error screen"
    errMode(1) = "View code (the page will not be executed)"
    errMode(2) = "Mark the error line in red"
    errMode(3) = "Brief (IIS like)"
    
    cgiTypes(0) = "None (executable files - exe, bat etc.)"
    cgiTypes(1) = "Full/system path to the CGI processor"
    cgiTypes(2) = "Relative to the virtual site"
    cgiTypes(3) = "Relative to the CGStandard.dll"

    Set cfg = Server.CreateObject("newObjects.utilctls.ConfigFile")
    Dim app, defaults
    
    If fileApp = "" Then
        ' Read default
        Set app = cfg.Read(Server.MapPath("/alp.application"))
        fileApp = pathFor & "alp.application"
        dirApp = pathFor
        cfg.Write fileApp,app
    Else
        Set app = cfg.Read(fileApp)
    End If
    
    Set defaults = cfg.Read(Server.MapPath("defaults.app"))

    Dim n, message, str, bShowMessageOnly, Module, ext
    message = ""
    bShowMessageOnly = False
    If Request("RemoveExt").Count > 0 Then
        bShowMessageOnly = True
        If Request("EXT") <> "." Then
            Set execMap = app("APPLICATION")("ExecutionMap")
            execMap.Remove Request("EXT")
            cfg.Write fileApp, app
            message = "File extension " & Request("EXT") & " has been removed. Default settings will apply for it."
        End If
    ElseIf Request("AddExt").Count > 0 Then
        str = CStr(Request("EXT"))
        If CheckExt(str) Then
            Set execMap = app("APPLICATION")("ExecutionMap")
            If IsObject(execMap(str)) Then
                message = "The specified extension already exists."
                bShowMessageOnly = True
            Else
                Select Case CStr(Request("MODULES"))
                    Case "ASP"
                        Set n = defaults("Modules")("ASP").Clone
                        execMap.Add str, n
                        Module = "ASP"
                        Set ext = n
                        cfg.Write fileApp, app
                    Case "RAW"
                        Set n = defaults("Modules")("RAW").Clone
                        execMap.Add str, n
                        Module = "RAW"
                        Set ext = n
                        cfg.Write fileApp, app
                    Case "CGI"
                        Set n = defaults("Modules")("CGI").Clone
                        execMap.Add str, n
                        Module = "CGI"
                        Set ext = n
                        cfg.Write fileApp, app
                    Case "TML"
                        Set n = defaults("Modules")("TML").Clone
                        execMap.Add str, n
                        Module = "TML"
                        Set ext = n
                        cfg.Write fileApp, app
                    Case Else
                        message = "Incorrect or unsupported module name. Note that this utility supports only the standard ALP modules. Custom modules should be configured manually"
                        bShowMessageOnly = True
                End Select
            End If
        Else
            bShowMessageOnly = True
            message = "Incorrect file extension specified."
        End If
    ElseIf Request("EditExt").Count > 0 Then
        str = CStr(Request("EXT"))
        If CheckExt(str) Then
            Set execMap = app("APPLICATION")("ExecutionMap")
            If Not IsObject(execMap(str)) Then
                message = "The specified extension does not exist."
                bShowMessageOnly = True
            Else
                Set ext = execMap(str)
                Module = GetModuleType(ext)
                If Module = "NIL" Then
                    message = "Incorrect or unsupported module name. Note that this utility supports only the standard ALP modules. Custom modules should be configured manually"
                    bShowMessageOnly = True
                End If
            End If
        Else
            bShowMessageOnly = True
            message = "Incorrect file extension specified."
        End If
    ElseIf Request("RAWAddLib").Count > 0 Then
        Set ext = app("APPLICATION")("ExecutionMap")(Request("EXT"))
        Module = CStr(Request("Module"))
        If Module = "RAW" Then
            If Not IsObject(ext("Library")) Then
                Set n = cfg.CreateRecord
                ext.Add "Library", n
            End If
            Set n = ext("Library")
            n.Add "", CStr(Request("LibFile"))
            cfg.Write fileApp, app
        End If
    ElseIf Request("RAWDelLib").Count > 0 Then
        Set ext = app("APPLICATION")("ExecutionMap")(Request("EXT"))
        Module = CStr(Request("Module"))
        If Module = "RAW" Then
            If IsObject(ext("Library")) Then
                Set n = ext("Library")
                n.Remove CLng(Request("LibFiles"))
                cfg.Write fileApp, app    
            End If
        End If
    ElseIf Request("Update").Count > 0 Then
        Set ext = app("APPLICATION")("ExecutionMap")(Request("EXT"))
        Module = CStr(Request("Module"))
        Select Case Module
            Case "RAW"
                If IsNumeric(Request("Timeout")) Then
                    If CLng(Request("Timeout")) > 10 Then ext("Timeout") = CLng(Request("Timeout"))
                End If
                If Request("IsScriptEngine").Count > 0 Then ext("IsScriptEngine") = CLng(1) Else ext("IsScriptEngine") = 0
                If Request("CheckThatFileExists").Count > 0 Then ext("CheckThatFileExists") = CLng(1) Else ext("CheckThatFileExists") = 0
                If Request("EnableParentPaths").Count > 0 Then ext("EnableParentPaths") = CLng(1) Else ext("EnableParentPaths") = 0
                If IsNumeric(Request("Timeout")) Then 
                    n = Clng(Request("Timeout"))
                    If n > 10 Then ext("Timeout") = n
                End If
                ext("ScriptLanguage") = CStr(Request("ScriptLanguage"))
                cfg.Write fileApp, app
            Case "ASP"
                If IsNumeric(Request("Timeout")) Then
                    If CLng(Request("Timeout")) > 10 Then ext("Timeout") = CLng(Request("Timeout"))
                End If
                If Request("IsScriptEngine").Count > 0 Then ext("IsScriptEngine") = CLng(1) Else ext("IsScriptEngine") = 0
                If Request("CheckThatFileExists").Count > 0 Then ext("CheckThatFileExists") = CLng(1) Else ext("CheckThatFileExists") = 0
                If Request("EnableParentPaths").Count > 0 Then ext("EnableParentPaths") = CLng(1) Else ext("EnableParentPaths") = 0
                ext("DefaultLanguage") = CStr(Request("DefaultLanguage"))
                ext("IISCompatible") = CLng(Request("IISCompatible"))
                ext("ViewSource") = CLng(Request("ViewSource"))
                If IsNumeric(Request("Timeout")) Then 
                    n = Clng(Request("Timeout"))
                    If n > 10 Then ext("Timeout") = n
                End If
                cfg.Write fileApp, app
            Case "CGI"
                If IsNumeric(Request("Timeout")) Then
                    If CLng(Request("Timeout")) > 10 Then ext("Timeout") = CLng(Request("Timeout"))
                End If
                If Request("IsScriptEngine").Count > 0 Then ext("IsScriptEngine") = CLng(1) Else ext("IsScriptEngine") = 0
                If Request("CheckThatFileExists").Count > 0 Then ext("CheckThatFileExists") = CLng(1) Else ext("CheckThatFileExists") = 0
                If Request("ShowErrOutputSample").Count > 0 Then ext("ShowErrOutputSample") = CLng(1) Else ext("ShowErrOutputSample") = 0
                If IsNumeric(Request("Timeout")) Then 
                    n = Clng(Request("Timeout"))
                    If n > 10 Then ext("Timeout") = n
                End If
                ext.Remove "Engine"
                ext.Remove ".Engine"
                ext.Remove ":Engine"
                Select Case CStr(Request("CGITYPE"))
                    Case "1"
                        ext.Add "Engine", CStr(Request("Engine"))
                    Case "2"
                        ext.Add ":Engine", CStr(Request("Engine"))
                    Case "3"
                        ext.Add ".Engine", CStr(Request("Engine"))
                End Select
                cfg.Write fileApp, app
            Case "TML"
                If Request("IsScriptEngine").Count > 0 Then ext("IsScriptEngine") = CLng(1) Else ext("IsScriptEngine") = 0
                If Request("CheckThatFileExists").Count > 0 Then ext("CheckThatFileExists") = CLng(1) Else ext("CheckThatFileExists") = 0
                AddTMLVars ext
                cfg.Write fileApp, app
        End Select
    Else
        bShowMessageOnly = True
    End IF
    Set execMap = app("APPLICATION")("ExecutionMap")
    
%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
</head>

<body topmargin="0" leftmargin="0">

<table border="0" width="100%" cellspacing="0">
  <!-- #include file="head.inc" -->
  <tr>
    <td width="100%">
        <H4>Current directory</H4>
        <BLOCKQUOTE>
            <%= pathFor %><BR>
            <A HREF="app.asp?Path=<%= pathFor %>">Back to application settings</A>
        </BLOCKQUOTE>
        <% If bShowMessageOnly Then %>
            <I><B><%= message %></B></I>
        <% Else %>
            <DIV ALIGN="CENTER">
            <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
                <INPUT TYPE="HIDDEN" NAME="Path" VALUE="<%= pathFor %>">
                <INPUT TYPE="HIDDEN" NAME="EXT" VALUE="<%= Request("EXT") %>">
                <INPUT TYPE="HIDDEN" NAME="Module" VALUE="<%= Module %>">
                <% Select Case Module 
                       Case "ASP" %>
                       <TABLE BORDER="0">
                            <TR>
                                <TD>
                                    Timeout
                                </TD>
                                <TD>
                                    <INPUT TYPE="TEXT" NAME="Timeout" VALUE="<%= ext("Timeout") %>"> sec.
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Default script language
                                </TD>
                                <TD>
                                    <INPUT TYPE="TEXT" NAME="DefaultLanguage" VALUE="<%= ext("DefaultLanguage") %>">
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    IIS compatibility level
                                </TD>
                                <TD>
                                    <SELECT NAME="IISCompatible">
                                        <% For I = 0 To 2 %>
                                            <% If I = ext("IISCompatible") Then %>
                                                <OPTION SELECTED VALUE="<%= I %>"><%= I %></OPTION>
                                            <% Else %>
                                                <OPTION VALUE="<%= I %>"><%= I %></OPTION>
                                            <% End If %>
                                        <% Next %>
                                    </SELECT>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Error mode
                                </TD>
                                <TD>
                                    <SELECT NAME="ViewSource">
                                        <% For I = 0 To 3 %>
                                            <% If I = ext("ViewSource") Then %>
                                                <OPTION SELECTED VALUE="<%= I %>"><%= errMode(I) %></OPTION>
                                            <% Else %>
                                                <OPTION VALUE="<%= I %>"><%= errMode(I) %></OPTION>
                                            <% End If %>
                                        <% Next %>
                                    </SELECT>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Treat as script engine
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="IsScriptEngine" VALUE="ON" <%= Checked(ext("IsScriptEngine")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Check that file exists
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="CheckThatFileExists" VALUE="ON" <%= Checked(ext("CheckThatFileExists")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Enable parent paths
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="EnableParentPaths" VALUE="ON" <%= Checked(ext("EnableParentPaths")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD COLSPAN="2">
                                    <A HREF="app-asp-alias.asp?Path=<%= pathFor %>">Edit COM aliases</A>
                                </TD>
                            </TR>
                            <TR>
                                <TD COLSPAN="2">
                                    <I>Note that ASP module has advanced setting that cannot be edited through this utility. If you want to configure ALP to run ASP pages 
                                    written in language different than VBScript/JScript you will need to edit the alp.application file manually.</I>
                                </TD>
                            </TR>
                        </TABLE>
                    <% Case "RAW" %>
                        <TABLE BORDER="0">
                            <TR>
                                <TD>
                                    Timeout
                                </TD>
                                <TD>
                                    <INPUT TYPE="TEXT" NAME="Timeout" VALUE="<%= ext("Timeout") %>"> sec.
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Script language
                                </TD>
                                <TD>
                                    <INPUT TYPE="TEXT" NAME="ScriptLanguage" VALUE="<%= ext("ScriptLanguage") %>">
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Treat as script engine
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="IsScriptEngine" VALUE="ON" <%= Checked(ext("IsScriptEngine")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Check that file exists
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="CheckThatFileExists" VALUE="ON" <%= Checked(ext("CheckThatFileExists")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Enable parent paths
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="EnableParentPaths" VALUE="ON" <%= Checked(ext("EnableParentPaths")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Library files
                                </TD>
                                <TD>
                                    <% If Not IsObject(ext("Library")) Then %>
                                        (None)<BR>
                                        <INPUT TYPE="TEXT" NAME="LibFile" VALUE="">
                                        <INPUT TYPE="SUBMIT" NAME="RAWAddLib" VALUE="Add">
                                    <% Else %>
                                        <SELECT NAME="LibFiles">
                                            <% For I = 1 To ext("Library").Count %>
                                                <OPTION VALUE="<%= I %>"><%= ext("Library")(I) %></OPTION>
                                            <% Next %>
                                        </SELECT><BR>
                                        <INPUT TYPE="TEXT" NAME="LibFile" VALUE="">
                                        <INPUT TYPE="SUBMIT" NAME="RAWAddLib" VALUE="Add">
                                        <INPUT TYPE="SUBMIT" NAME="RAWDelLib" VALUE="Remove">
                                    <% End If %>
                                    
                                </TD>
                            </TR>
                        </TABLE>
                    <% Case "CGI" %>
                        <TABLE BORDER="0">
                            <TR>
                                <TD>
                                    Timeout
                                </TD>
                                <TD>
                                    <INPUT TYPE="TEXT" NAME="Timeout" VALUE="<%= ext("Timeout") %>"> sec.
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    CGI processor
                                </TD>
                                <TD>
                                    <%
                                        Dim CGIType, engine
                                        CGIType = 0
                                        engine = ""
                                        If Not IsEmpty(ext("Engine")) Then
                                            CGIType = 1
                                            engine = ext("Engine")
                                        ElseIf Not IsEmpty(ext(":Engine")) Then
                                            CGIType = 2
                                            engine = ext(":Engine")
                                        ElseIf Not IsEmpty(ext(".Engine")) Then
                                            CGIType = 3
                                            engine = ext(".Engine")
                                        End If
                                        
                                    %>
                                    Path to the CGI processor is specified:<BR>
                                    <SELECT NAME="CGITYPE">
                                        <% For I = 0 To 3 %>
                                           <% If I = CGIType Then %>
                                                <OPTION SELECTED VALUE="<%= I %>"><%= cgiTypes(I) %></OPTION>
                                           <% Else %>
                                                <OPTION VALUE="<%= I %>"><%= cgiTypes(I) %></OPTION>
                                           <% End If %> 
                                        <% Next %>
                                    </SELECT>
                                    <BR>
                                    <INPUT TYPE="TEXT" NAME="Engine" VALUE="<%= engine %>" SIZE="50">
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Treat as script engine
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="IsScriptEngine" VALUE="ON" <%= Checked(ext("IsScriptEngine")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Check that file exists
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="CheckThatFileExists" VALUE="ON" <%= Checked(ext("CheckThatFileExists")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Show error output
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="ShowErrOutputSample" VALUE="ON" <%= Checked(ext("ShowErrOutputSample")) %>>
                                </TD>
                            </TR>
                        </TABLE>
                    <% Case "TML" %>
                        <TABLE BORDER="0">
                            <TR>
                                <TD>
                                    Treat as script engine
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="IsScriptEngine" VALUE="ON" <%= Checked(ext("IsScriptEngine")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Check that file exists
                                </TD>
                                <TD>
                                    <INPUT TYPE="CHECKBOX" NAME="CheckThatFileExists" VALUE="ON" <%= Checked(ext("CheckThatFileExists")) %>>
                                </TD>
                            </TR>
                            <TR>
                                <TD>
                                    Global variables
                                </TD>
                                <TD>
                                    <%
                                        Dim tmlVars, vars, varset
                                        tmlVars = ""
                                        If IsObject(ext("REPLACE")) Then
                                            Set vars = ext("REPLACE")
                                            For I = 1 To vars.Count
                                                Set varset = vars(I)
                                                For J = 1 To varset.Count
                                                    tmlVars = tmlVars & vars.Key(I) & "=" & varset(J) & vbCrLf
                                                Next
                                            Next
                                        End If
                                    %>
                                    <TEXTAREA NAME="Vars" COLS="30" ROWS="6"><%= tmlVars %></TEXTAREA>
                                </TD>
                            </TR>
                        </TABLE>
                <% End Select %>
                <DIV ALIGN="CENTER">
                    <INPUT TYPE="SUBMIT" NAME="Update" VALUE="Update">
                    <INPUT TYPE="RESET" VALUE="Reset">
                </DIV>
            </FORM>
            </DIV>
        <% End If %>
    </td>
  </tr>
</table>

</body>

</html>
